import es
import gamethread
from donormod import donormod as donor
benefit = "lazerscout"

def load():
    donor.registerbenefit(benefit, 3000, "Lazer Scout", "Monthly")
    es.server.queuecmd("eventscripts_noisy 1")
    gamethread.delayed(10, removescouts, ())

def player_spawn(ev):
    if donor.checkbenefit(ev['userid'], benefit, False):
        es.server.cmd('es_xgive %s %s' % (ev['userid'], "weapon_scout"))

def removescouts():
    weplist = es.createentitylist()
    weapons = filter(lambda x: weplist[x]['classname'].startswith('weapon_'), list(weplist))
    for weapon in weapons:
        owner = es.getindexprop(weapon, 'CBaseEntity.m_hOwnerEntity')
        if weplist[weapon]['classname'] == 'weapon_scout':
            if owner == -1:
                es.server.queuecmd("est_dissolve %s" % weapon)
            else:
                for userid in es.getUseridList():
                    if owner == es.getplayerhandle(userid) and not donor.checkbenefit(userid, benefit, False):
                        es.server.queuecmd("est_dissolve %s" % weapon)
    gamethread.delayed(10, removescouts)

def bullet_impact(ev):
    if donor.checkbenefit(ev['userid'], benefit, False) and ev['es_userweapon'] == "weapon_scout":
        x2, y2, z2 = es.getplayerlocation(ev['userid'])
        x1, y1, z1 = (ev['x'], ev['y'], ev['z'])
        es.server.queuecmd('est_effect 3 #a 0 sprites/physcannon_bluelight2.vmt %s %s %s %s %s %s 0.5 0.5 1 255 0 255 255' % (x1, y1, z1, x2, y2, int(z2)+60))
